



import java.util.ArrayList;
import java.util.HashMap;

import org.eclipse.birt.data.engine.api.IResultMetaData;
import org.eclipse.birt.data.engine.core.DataException;
import org.eclipse.birt.report.engine.api.EngineConfig;
import org.eclipse.birt.report.engine.api.EngineConstants;
import org.eclipse.birt.report.engine.api.EngineException;
import org.eclipse.birt.report.engine.api.HTMLRenderContext;
import org.eclipse.birt.report.engine.api.IDataExtractionTask;
import org.eclipse.birt.report.engine.api.IDataIterator;
import org.eclipse.birt.report.engine.api.IExtractionResults;
import org.eclipse.birt.report.engine.api.IReportDocument;
import org.eclipse.birt.report.engine.api.IReportRunnable;
import org.eclipse.birt.report.engine.api.IRunTask;
import org.eclipse.birt.report.engine.api.ReportEngine;
import org.eclipse.birt.report.engine.api.impl.IResultSetItem;

public class DataExtract {

	static void readReport() throws EngineException
	{
		//Engine Configuration - set and get temp dir, BIRT home, Servlet context
		EngineConfig config = new EngineConfig();
		config.setEngineHome( ExampleConstants.BIRT_HOME );	
        
		//Create the report engine
		ReportEngine engine = new ReportEngine( config );
			
		
		//Open a report design - use design to modify design, retrieve embedded images etc. 
		IReportRunnable design = engine.openReportDesign(ExampleConstants.TOC_EXAMPLE + ".rptdesign"); 
		
		//Create task to run the report - use the task to execute and run the report,
		IRunTask task = engine.createRunTask(design); 
	
		
		//Set Render context to handle url and image locataions
		HTMLRenderContext renderContext = new HTMLRenderContext();
		renderContext.setImageDirectory("image");
		HashMap contextMap = new HashMap();
		contextMap.put( EngineConstants.APPCONTEXT_HTML_RENDER_CONTEXT, renderContext );
		task.setAppContext( contextMap );
		
		
		//run the report and save the report document
		task.run(ExampleConstants.TOC_EXAMPLE + ".rptdocument");		
		
		IReportDocument iReportDocument = engine.openReportDocument(ExampleConstants.TOC_EXAMPLE + ".rptdocument");
		
		//Setup data extraction task
		IDataExtractionTask iDataExtract = engine.createDataExtractionTask(iReportDocument);
		
		
		/**
		 * returns the metadata corresponding to the data stored in the report
		 * document.  Could specify a component.
		 */
		ArrayList resultSetList = (ArrayList)iDataExtract.getResultSetList( );
		
		IResultSetItem resultItem = (IResultSetItem)resultSetList.get( 0 );
		String dispName = resultItem.getResultSetName( );
		iDataExtract.selectResultSet( dispName );

		IExtractionResults iExtractResults = iDataExtract.extract();
		IDataIterator iData = null;
		try{
			if ( iExtractResults != null )
			{
				iData = iExtractResults.nextResultIterator( );
				
				//Get metadata on retrieved results
				IResultMetaData irmd = iData.getResultMetaData();
				if ( iData != null  ){
					int colCount = irmd.getColumnCount();
					System.out.println("Cloumn Count =" + colCount );
					for( int j=0; j< colCount; j++){
						System.out.println("Cloumn Name =" + irmd.getColumnName(j) );
						System.out.println("Cloumn Type =" + irmd.getColumnTypeName(j) );
					}
				
					while ( iData.next( ) )
					{	
						//Just disply the first two columns
						Object objColumn1;
					    Object objColumn2;
						try{
							objColumn1 = iData.getValue(0);
						}catch(DataException e){
							objColumn1 = new String("");
						}
						try{
							objColumn2 = iData.getValue(1);
						}catch(DataException e){
							objColumn2 = new String("");
						}
							System.out.println( objColumn1 + " , " + objColumn2 );
					}
					iData.close();
				}
			}
		}
		catch( Exception e){
			e.printStackTrace();
		}

		iDataExtract.close();
		engine.destroy();
	}	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try
		{
			readReport( );
		}
		catch ( Exception e )
		{
			e.printStackTrace();
		}
	}

}
