



import java.util.HashMap;

import org.eclipse.birt.report.engine.api.EngineConfig;
import org.eclipse.birt.report.engine.api.EngineConstants;
import org.eclipse.birt.report.engine.api.EngineException;
import org.eclipse.birt.report.engine.api.HTMLEmitterConfig;
import org.eclipse.birt.report.engine.api.HTMLRenderContext;
import org.eclipse.birt.report.engine.api.HTMLRenderOption;
import org.eclipse.birt.report.engine.api.IReportRunnable;
import org.eclipse.birt.report.engine.api.IRunAndRenderTask;
import org.eclipse.birt.report.engine.api.ReportEngine;
public class DrillReport {

	static void drillReport() throws EngineException
	{
		//Engine Configuration - set and get temp dir, BIRT home, Servlet context
		EngineConfig config = new EngineConfig();
		config.setEngineHome( ExampleConstants.BIRT_HOME );	
		
		
		// Create the emitter configuration.
		// used for setting action and image handlers
		HTMLEmitterConfig emitterConfig = new HTMLEmitterConfig( );
		emitterConfig.setActionHandler( new MyActionHandler( ) );
		config.getEmitterConfigs( ).put( "html", emitterConfig ); 		
	  
		//Create the report engine
		ReportEngine engine = new ReportEngine( config );
		

		//Open a report design - use design to modify design, retrieve embedded images etc. 
		IReportRunnable design = engine.openReportDesign(ExampleConstants.DRILL + "master.rptdesign"); 
		
		//Create task to run the report - use the task to execute and run the report,
		IRunAndRenderTask task = engine.createRunAndRenderTask(design); 
		//config.setTempDir("c:/work/test/tmp");
		
		//Can be set in HTMLEmitterConfig or HTMLRenderOptions
		MyActionHandler myActionHandler = new MyActionHandler();
		
	
		//Set Render context to handle url and image locataions
		//Can use PDFRenderContext for font manipulation
		HTMLRenderContext renderContext = new HTMLRenderContext();
		
		renderContext.setBaseURL( "file://" + ExampleConstants.DRILL );
		renderContext.setImageDirectory("image");
		HashMap contextMap = new HashMap();
		contextMap.put( EngineConstants.APPCONTEXT_HTML_RENDER_CONTEXT, renderContext );
		task.setAppContext( contextMap );
		
		
		//Set rendering options - such as file or stream output, 
		//output format, whether it is embeddable, etc
		HTMLRenderOption options = new HTMLRenderOption();
		options.setEmbeddable(true);
		options.setOutputFileName(ExampleConstants.DRILL + "master.html");
		options.setOutputFormat("html");
		options.setActionHandle(myActionHandler);
		task.setRenderOption(options);
		

		//run the report and destroy the engine
		task.run();
		engine.destroy();
	}	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try
		{
			drillReport( );
		}
		catch ( Exception e )
		{
			e.printStackTrace();
		}
	}

}
