



import java.util.HashMap;

import org.eclipse.birt.report.engine.api.EngineConfig;
import org.eclipse.birt.report.engine.api.EngineException;
import org.eclipse.birt.report.engine.api.HTMLRenderContext;
import org.eclipse.birt.report.engine.api.HTMLRenderOption;

import org.eclipse.birt.report.engine.api.IReportRunnable;
import org.eclipse.birt.report.engine.api.IRunAndRenderTask;
import org.eclipse.birt.report.engine.api.ReportEngine;
import org.eclipse.birt.report.engine.api.EngineConstants;

public class ExecuteReportSO {

	static void executeReport() throws EngineException
	{
		//Engine Configuration - set and get temp dir, BIRT home, Servlet context
		EngineConfig config = new EngineConfig();
		config.setEngineHome( ExampleConstants.BIRT_HOME );	
       
		
		//Create the report engine
		ReportEngine engine = new ReportEngine( config );
		

		//Open a report design - use design to modify design, retrieve embedded images etc. 
		IReportRunnable design = engine.openReportDesign(ExampleConstants.SCRIPT_OBJ + ".rptdesign"); 
		
		//Create task to run the report - use the task to execute and run the report,
		IRunAndRenderTask task = engine.createRunAndRenderTask(design); 
		//config.setTempDir("c:/work/test/tmp");
		
		//Set Render context to handle url and image locataions
		HTMLRenderContext renderContext = new HTMLRenderContext();
		renderContext.setImageDirectory("image");
		HashMap contextMap = new HashMap();
		contextMap.put( EngineConstants.APPCONTEXT_HTML_RENDER_CONTEXT, renderContext );
		task.setAppContext( contextMap );
		
		Benefits bn = new Benefits();
		bn.setPlanNumber(5);
		bn.setSSN("123-45-6789");
		bn.setUserName("JoeEclipse");
		
		task.addScriptableJavaObject("Benefits", bn);
		
		
		//Set rendering options - such as file or stream output, 
		//output format, whether it is embeddable, etc
		HTMLRenderOption options = new HTMLRenderOption();
		options.setEmbeddable(true);
		options.setOutputFileName(ExampleConstants.SCRIPT_OBJ + "Benefits.html");
		options.setOutputFormat("html");
		task.setRenderOption(options);
		

		//run the report and destroy the engine
		task.run();
		task.close();
		engine.destroy();
				
	}	

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try
		{
			executeReport( );
		}
		catch ( Exception e )
		{
			e.printStackTrace();
		}
	}

}
