import java.util.HashMap;

import org.eclipse.birt.report.engine.api.EngineConfig;
import org.eclipse.birt.report.engine.api.EngineConstants;
import org.eclipse.birt.report.engine.api.EngineException;
import org.eclipse.birt.report.engine.api.HTMLRenderContext;
import org.eclipse.birt.report.engine.api.HTMLRenderOption;
import org.eclipse.birt.report.engine.api.IRenderTask;
import org.eclipse.birt.report.engine.api.IReportDocument;
import org.eclipse.birt.report.engine.api.IReportRunnable;
import org.eclipse.birt.report.engine.api.IRunTask;
import org.eclipse.birt.report.engine.api.ReportEngine;

public class RenderReport
{

	static void renderReport() throws EngineException {
		//Engine Configuration - set and get temp dir, BIRT home, Servlet context
		EngineConfig config = new EngineConfig();
		config.setEngineHome(ExampleConstants.BIRT_HOME);

		//Create the report engine
		ReportEngine engine = new ReportEngine(config);

		//Open a report design - use design to modify design, retrieve embedded images etc. 
		IReportRunnable design = engine.openReportDesign(ExampleConstants.RENDER + ".rptdesign");

		//Create task to run the report - use the task to execute and run the report,
		IRunTask runTask = engine.createRunTask(design);

		//run the report and destroy the engine
		runTask.run(ExampleConstants.RENDER + ".rptdocument");

		//Open a report document 
		IReportDocument iReportDocument = engine.openReportDocument(ExampleConstants.RENDER + ".rptdocument");
		IRenderTask task = engine.createRenderTask(iReportDocument);
		System.out.println("============================== " + iReportDocument.getPageCount());

		//Set Render context to handle url and image locataions
		HTMLRenderContext renderContext = new HTMLRenderContext();
		renderContext.setImageDirectory("image");
		HashMap contextMap = new HashMap();
		contextMap.put(EngineConstants.APPCONTEXT_HTML_RENDER_CONTEXT, renderContext);
		task.setAppContext(contextMap);

		//Set Render Options
		HTMLRenderOption options = new HTMLRenderOption();
		//options.setOutputStream(System.out);
		options.setOutputFileName(ExampleConstants.RENDER + "pages.html");
		options.setOutputFormat("html");
		task.setRenderOption(options);

		task.render("1");
		task.close();
		engine.destroy();
	}

	public static void main(String[] args) {
		try {
			renderReport();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
