



import java.util.Collection;

import org.eclipse.birt.core.exception.BirtException;
import org.eclipse.birt.data.engine.api.IBaseExpression;
import org.eclipse.birt.data.engine.api.IQueryResults;
import org.eclipse.birt.data.engine.api.IResultIterator;
import org.eclipse.birt.report.engine.api.EngineConfig;
import org.eclipse.birt.report.engine.api.EngineException;
import org.eclipse.birt.report.engine.api.IDataPreviewTask;
import org.eclipse.birt.report.engine.api.IReportRunnable;
import org.eclipse.birt.report.engine.api.ReportEngine;


public class ReportDataPreview {

	static void DataPreview() throws EngineException
	{
		//Engine Configuration - set and get temp dir, BIRT home, Servlet context
		EngineConfig config = new EngineConfig();
		config.setEngineHome( ExampleConstants.BIRT_HOME );	
        
		//Create the report engine
		ReportEngine engine = new ReportEngine( config );
		

		//Open a report design - use design to modify design, retrieve embedded images etc. 
		IReportRunnable design = engine.openReportDesign(ExampleConstants.DATA_PREVIEW + ".rptdesign"); 
		
		//Create task to run the report - use the task to execute and run the report,
		IDataPreviewTask task = engine.createDataPreviewTask(design); 	
		IQueryResults actualResultSet = task.executeDataSet("Customer Sales", 10, null);

		try{
			if ( actualResultSet != null )
			{	
				//Get column count and names
				Collection col = actualResultSet.getPreparedQuery( ).getReportQueryDefn( ).getRowExpressions( );
				IBaseExpression[] expressions = (IBaseExpression[])col.toArray( new IBaseExpression[col.size( )]);
				
				//Get results of query
				IResultIterator iter = actualResultSet.getResultIterator( );
		
				int columnCount = expressions.length;				
				for ( int n = 0; n < columnCount; n++ )
				{
					System.out.print( actualResultSet.getResultMetaData().getColumnName(n+1) + "--" );
				}				
				System.out.println("");
				while ( iter.next( ) )
				{
					for ( int n = 0; n < columnCount; n++ )
					{
						System.out.print( iter.getString( expressions[n] )+ "--" );
					}
					System.out.println("");

				}
				actualResultSet.close( );
			}		
		} catch ( BirtException ex )
		{
			ex.printStackTrace( );
		}
					
		engine.destroy();
	}	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try
		{
			DataPreview( );
		}
		catch ( Exception e )
		{
			e.printStackTrace();
		}
	}

}
