



import java.util.HashMap;
import java.util.List;

import org.eclipse.birt.report.engine.api.EngineConfig;
import org.eclipse.birt.report.engine.api.EngineConstants;
import org.eclipse.birt.report.engine.api.EngineException;
import org.eclipse.birt.report.engine.api.HTMLRenderContext;
import org.eclipse.birt.report.engine.api.IReportDocument;
import org.eclipse.birt.report.engine.api.IReportRunnable;
import org.eclipse.birt.report.engine.api.IRunTask;
import org.eclipse.birt.report.engine.api.ReportEngine;
import org.eclipse.birt.report.engine.api.TOCNode;

public class TocExtract {

	static void readReport() throws EngineException
	{
		//Engine Configuration - set and get temp dir, BIRT home, Servlet context
		EngineConfig config = new EngineConfig();
		config.setEngineHome( ExampleConstants.BIRT_HOME );	
        
		//Create the report engine
		ReportEngine engine = new ReportEngine( config );
			
		
		//Open a report design - use design to modify design, retrieve embedded images etc. 
		IReportRunnable design = engine.openReportDesign(ExampleConstants.TOC_EXAMPLE + ".rptdesign"); 
		
		//Create task to run the report - use the task to execute and run the report,
		IRunTask task = engine.createRunTask(design); 
	
		
		//Set Render context to handle url and image locataions
		HTMLRenderContext renderContext = new HTMLRenderContext();
		renderContext.setImageDirectory("image");
		HashMap contextMap = new HashMap();
		contextMap.put( EngineConstants.APPCONTEXT_HTML_RENDER_CONTEXT, renderContext );
		task.setAppContext( contextMap );
		
		
		//run the report and save the report document
		task.run(ExampleConstants.TOC_EXAMPLE + ".rptdocument");		
		
		IReportDocument iReportDocument = engine.openReportDocument(ExampleConstants.TOC_EXAMPLE + ".rptdocument");
		
		TOCNode td;
		
		//use Nodeid below to recurse through each level
		td = iReportDocument.findTOC(null);
	

		List children = td.getChildren( );
		//Loop through Top Level Children
		if ( children != null && children.size( ) > 0 )
		{
			for ( int i = 0; i < children.size( ); i++ )
			{
				TOCNode child = ( TOCNode ) children.get( i );
				System.out.println( "Node ID " + child.getNodeID());
				
				System.out.println( "Node Display String " + child.getDisplayString());
				System.out.println( "Node Bookmark " + child.getBookmark());
				
			}
		}	

		task.close();
		engine.destroy();
		
	}	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try
		{
			readReport( );
		}
		catch ( Exception e )
		{
			e.printStackTrace();
		}
	}

}
